#ifndef NODE_HPP
#define NODE_HPP

class Node {
public:
    // default constructor creates a leaf node
    Node() = default;
    // whoever creates the node is responsible for deciding which particles are in which octant and for allocating the localParticles array 
    // node will write to localParticles array
    Node(Node* parent, double* particles, unsigned nParticles, unsigned depth, double size, double center[3], unsigned* localParticles, unsigned nLocalParticles);
    ~Node();
private:
    Node* root_;
    Node* parent_;
    Node* children_[8];
    double* particles_;
    unsigned nParticles_;
    unsigned depth_;
    double size_;
    double center_[3];
    unsigned* localParticles_;
    unsigned nLocalParticles_;
};

#endif /* NODE_HPP */